function emptyArr(w,h)
  local T = {}
  for i=1,h do
    table.insert(T,{})
    for j=1,w do
      table.insert(T[i],0)
    end
  end
  return T
end

mapwidth = 20
mapheight = 20
theMap = emptyArr(mapwidth,mapheight)

blockSize = love.graphics.getWidth()/mapwidth

state = "edit"

stateDescs = {["edit"]="Use the arrow keys to move the cursor. \nPress 0 or 1 or 2 to:\n1-add water\n2-add wall\n0-erase",["test"]="Watch and enjoy!"}

pointer = {x=1,y=1}

function checkFill()
  local toAdd = {}
  for y=1,mapheight do
    for x=1,mapwidth do
      if theMap[y][x] == 1 then
        if y < mapheight and theMap[y+1][x] == 0 then table.insert(toAdd,{y+1,x}) end
        if y > 1 and theMap[y-1][x] == 0 then table.insert(toAdd,{y-1,x}) end
        if theMap[y][x+1] == 0 and x < mapwidth then table.insert(toAdd,{y,x+1}) end
        if theMap[y][x-1] == 0 and x > 1 then table.insert(toAdd,{y,x-1}) end
      end
    end
  end
  for i,l in pairs(toAdd) do
    theMap[l[1]][l[2]] = 1
  end
end

checkTimer = 0
checkTimerMax = 1.5

function love.update()
  if state == "test" then
    if checkTimer < checkTimerMax then checkTimer = checkTimer + 0.1 else
      checkTimer = 0
      checkFill()
    end
  elseif state == "edit" then
    
  end
end

function love.keypressed(key)
  if state == "edit" then
    if key == 'left' and pointer.x > 1 then pointer.x = pointer.x - 1 end
    if key == 'right' and pointer.x < mapwidth then pointer.x = pointer.x + 1 end
    if key == 'up' and pointer.y > 1 then pointer.y = pointer.y - 1 end
    if key == 'down' and pointer.y < mapheight then pointer.y = pointer.y + 1 end
    if key == '0' or key == '1' or key == '2' then
      theMap[pointer.y][pointer.x] = tonumber(key)
    end
    if key == 'return' then state = "test" end
  elseif state == "test" then
    if key == 'return' then state = "edit";checkTimer = 0 end
  end
  if key == 'r' then theMap = emptyArr(mapwidth,mapheight) end
end
function love.draw()
  for y=1,mapheight do
    for x=1,mapwidth do
      if theMap[y][x] == 1 then
        love.graphics.setColor(0,200,255)
        love.graphics.rectangle("fill",(x-1)*blockSize,(y-1)*blockSize,blockSize,blockSize)
      elseif theMap[y][x] == 2 then
        love.graphics.setColor(100,100,100)
        love.graphics.rectangle("fill",(x-1)*blockSize,(y-1)*blockSize,blockSize,blockSize)
      end
    end
  end
  if state == "edit" then
    love.graphics.setColor(255,255,0,200)
    love.graphics.rectangle("fill",(pointer.x-1)*blockSize,(pointer.y-1)*blockSize,blockSize,blockSize)
  end
  love.graphics.setColor(255,255,0)
  love.graphics.print("You are now " .. state .. "ing, press ENTER to switch\n\n" .. stateDescs[state])
end